﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.Windows.Controls;

namespace SaveProperties
{
    public class Employee : ViewModelBase
    {
        private static BackUpData backUpEmployee;      

        public Employee()
        {
            backUpEmployee = new BackUpData();
        }

        private string firstName;

        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; this.OnPropertyChanged("FirstName"); }
        }

        private string lastName;

        public string LastName
        {
            get { return lastName; }
            set { lastName = value; this.OnPropertyChanged("LastName"); }
        }


        private string occupation;

        public string Occupation
        {
            get { return occupation; }
            set { occupation = value; this.OnPropertyChanged("Occupation"); }
        }

        private bool isMarried;

        public bool IsMarried
        {
            get { return isMarried; }
            set { isMarried = value; this.OnPropertyChanged("IsMarried"); }
        }

        private decimal salary;

        public decimal Salary
        {
            get { return salary; }
            set { salary = value; this.OnPropertyChanged("Salary"); }
        }
        private int age;

        public int Age
        {
            get { return age; }
            set { age = value; this.OnPropertyChanged("Age"); }
        }

        public void CreateBackUp()
        {
            backUpEmployee.FirstName = this.FirstName;
            backUpEmployee.LastName = this.LastName;
            backUpEmployee.Occupation = this.Occupation;
            backUpEmployee.IsMarried = this.IsMarried;
            backUpEmployee.Salary = this.Salary;
        }
        public void RestoreBackUp()
        {
            this.FirstName = backUpEmployee.FirstName;
            this.LastName = backUpEmployee.LastName;
            this.Occupation = backUpEmployee.Occupation;
            this.IsMarried = backUpEmployee.IsMarried;
            this.Salary = backUpEmployee.Salary;
        }
    }
    class BackUpData
    {
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string Occupation { get; set; }
        public bool IsMarried { get; set; }
        public decimal Salary { get; set; }
    }
}
