﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls.Data.PropertyGrid;

namespace SaveProperties
{
   public class FieldTemplateSelector : DataTemplateSelector
    {
        public DataTemplate StringDataTemplate { get; set; }
        public DataTemplate NumericDataTemplate { get; set; }
        public DataTemplate CurrencyDataTemplate { get; set; }
        public DataTemplate DistanceDataTemplate { get; set; }
        public DataTemplate ReadOnlyDataTemplate { get; set; }
        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            var definition = item as PropertyDefinition;
            if(definition.SourceProperty.PropertyType == typeof(string))
            {
                return StringDataTemplate;
            }
            else if (definition.SourceProperty.PropertyType == typeof(int))
            {
                return NumericDataTemplate;
            }
            else if (definition.SourceProperty.PropertyType == typeof(decimal))
            {
                return CurrencyDataTemplate;
            }
            return base.SelectTemplate(item, container);
        }
    }
}
